{**********************************************}
{                                              }
{     FastReport 2.5 - SQLDirect components    }
{           Macro params editor                }
{                                              }
{   Copyright (c) 1997-2007 by Yuri Sheino.    }
{   Copyright (c) 1998-2007 by Tzyganenko A.   }
{ Copyright (c) 2001-2007 by Stalker SoftWare  }
{                                              }
{**********************************************}

unit FR_SDMacroParam;

interface

{$I FR.inc}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FR_Ctrls, ExtCtrls, DB, FR_SDMacroQuery, SDEngine;

type
  TfrSDMacroParamsForm = class(TForm)
    GroupBox1: TGroupBox;
    Label2: TLabel;
    ParamsLB: TListBox;
    Label1: TLabel;
    ValueE: TfrComboEdit;
    Button1: TButton;
    Button2: TButton;
    DataTypeCB: TComboBox;
    ValueRB: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure ParamsLBClick(Sender: TObject);
    procedure ValueEExit(Sender: TObject);
    procedure DataTypeCBChange(Sender: TObject);
    procedure ValueRBClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure VarSBClick(Sender: TObject);
  private
    { Private declarations }
    FBusy: Boolean;
    function CurParam: Integer;
    procedure Localize;
  public
    { Public declarations }
    Query: TSDMacroQuery;
    QueryComp: TfrSDMacroQuery;
  end;


const
  SDDataTypes: Array[0..10] of TFieldType =
    (ftBCD, ftBoolean, ftCurrency, ftDate, ftDateTime, ftInteger,
     ftFloat, ftSmallint, ftString, ftTime, ftWord);

implementation

uses
  FR_Const, FR_Class, FR_DBUtils, FR_Utils;

{$R *.DFM}

  
function TfrSDMacroParamsForm.CurParam: Integer;
var
  i: Integer;
  s: String;

begin

 Result := 0;
 s := ParamsLB.Items[ParamsLB.ItemIndex];
 for i := 0 to Query.Macros.Count - 1 do
   if Query.Macros[i].Name = s then begin
     Result := i;
     Break;
   end; { if }

end; { CurParam }

procedure TfrSDMacroParamsForm.FormShow(Sender: TObject);
var
  i: Integer;

begin

 with TSDMacroQuery(Query).Macros do
   for i := 0 to Count - 1 do
     if ParamsLB.Items.IndexOf(Items[i].Name) = -1 then
       ParamsLB.Items.Add(Items[i].Name);

 for i := 0 to 10 do
   DataTypeCB.Items.Add(frLoadStr(SParamType1 + i));

 ParamsLB.ItemIndex := 0;
 ParamsLBClick(nil);

end; { FormShow }

procedure TfrSDMacroParamsForm.FormHide(Sender: TObject);
begin
 if ValueE.Enabled then ValueEExit(nil);
end; { FormHide }

procedure TfrSDMacroParamsForm.ParamsLBClick(Sender: TObject);
var
  i   :Integer;

begin

 DataTypeCB.ItemIndex := -1;
 for i := 0 to 10 do
   if Query.Macros[CurParam()].DataType = SDDataTypes[i] then begin
     DataTypeCB.ItemIndex := i;
     Break;
   end; { if }

 FBusy := True;
 ValueE.Text := '';
 ValueE.Enabled := False;

 ValueE.Text := QueryComp.MacroParamText[CurParam()];
 ValueE.Enabled := True;

 FBusy := False;

end; { ParamsLBClick }

procedure TfrSDMacroParamsForm.ValueEExit(Sender: TObject);
begin
 QueryComp.MacroParamText[CurParam()] := ValueE.Text;
end; { ValueEExit }

procedure TfrSDMacroParamsForm.DataTypeCBChange(Sender: TObject);
begin
 Query.Macros[CurParam()].DataType := SDDataTypes[DataTypeCB.ItemIndex];
 if ValueE.Enabled then ValueEExit(nil);
end; { DataTypeCBChange }

procedure TfrSDMacroParamsForm.ValueRBClick(Sender: TObject);
begin
 if FBusy then Exit;
 ValueE.Enabled := True;
end; { ValueRBClick }

procedure TfrSDMacroParamsForm.Localize;
begin
 GroupBox1.Caption := frLoadStr(frRes + 3110);
 Label2.Caption := frLoadStr(frRes + 3111);
 Label1.Caption := frLoadStr(frRes + 3112);
 ValueRB.Caption := frLoadStr(frRes + 3113);
 ValueE.ButtonHint := frLoadStr(frRes + 575);
 Button1.Caption := frLoadStr(SOk);
 Button2.Caption := frLoadStr(SCancel);
end;

procedure TfrSDMacroParamsForm.FormCreate(Sender: TObject);
begin
 Localize;
end; { FormCreate }

procedure TfrSDMacroParamsForm.VarSBClick(Sender: TObject);
begin
 ValueE.Text := frDesigner.InsertExpression;
end; { VarSBClick }

end.

